ActiveResource::Base is the main class for mapping RESTful resources as models in a Rails application.

For an outline of what Active Resource is capable of, see files/vendor/rails/activeresource/README.html.

Automated mapping

Active Resource objects represent your RESTful resources as manipulatable Ruby objects. To map resources to Ruby objects, Active Resource only needs a class name that corresponds to the resource name (e.g., the class Person maps to the resources people, very similarly to Active Record) and a site value, which holds the URI of the resources.

  class Person < ActiveResource::Base
    self.site = "http://api.people.com:3000/"
  end

Now the Person class is mapped to RESTful resources located at api.people.com:3000/people/, and you can now use Active Resource‘s lifecycles methods to manipulate resources. In the case where you already have an existing model with the same name as the desired RESTful resource you can set the element_name value.

  class PersonResource < ActiveResource::Base
    self.site = "http://api.people.com:3000/"
    self.element_name = "person"
  end

Lifecycle methods

Active Resource exposes methods for creating, finding, updating, and deleting resources from REST web services.

  ryan = Person.new(:first => 'Ryan', :last => 'Daigle')
  ryan.save                # => true
  ryan.id                  # => 2
  Person.exists?(ryan.id)  # => true
  ryan.exists?             # => true

  ryan = Person.find(1)
  # Resource holding our newly created Person object

  ryan.first = 'Rizzle'
  ryan.save                # => true

  ryan.destroy             # => true

As you can see, these are very similar to Active Record‘s lifecycle methods for database records. You can read more about each of these methods in their respective documentation.

Custom REST methods

Since simple CRUD/lifecycle methods can‘t accomplish every task, Active Resource also supports defining your own custom REST methods. To invoke them, Active Resource provides the get, post, put and \delete methods where you can specify a custom REST method name to invoke.

  # POST to the custom 'register' REST method, i.e. POST /people/new/register.xml.
  Person.new(:name => 'Ryan').post(:register)
  # => { :id => 1, :name => 'Ryan', :position => 'Clerk' }

  # PUT an update by invoking the 'promote' REST method, i.e. PUT /people/1/promote.xml?position=Manager.
  Person.find(1).put(:promote, :position => 'Manager')
  # => { :id => 1, :name => 'Ryan', :position => 'Manager' }

  # GET all the positions available, i.e. GET /people/positions.xml.
  Person.get(:positions)
  # => [{:name => 'Manager'}, {:name => 'Clerk'}]

  # DELETE to 'fire' a person, i.e. DELETE /people/1/fire.xml.
  Person.find(1).delete(:fire)

For more information on using custom REST methods, see the ActiveResource::CustomMethods documentation.

Validations

You can validate resources client side by overriding validation methods in the base class.

  class Person < ActiveResource::Base
     self.site = "http://api.people.com:3000/"
     protected
       def validate
         errors.add("last", "has invalid characters") unless last =~ /[a-zA-Z]*/
       end
  end

See the ActiveResource::Validations documentation for more information.

Authentication

Many REST APIs will require authentication, usually in the form of basic HTTP authentication. Authentication can be specified by:

  • putting the credentials in the URL for the site variable.
     class Person < ActiveResource::Base
       self.site = "http://ryan:password@api.people.com:3000/"
     end
    
  • defining user and/or password variables
     class Person < ActiveResource::Base
       self.site = "http://api.people.com:3000/"
       self.user = "ryan"
       self.password = "password"
     end
    

For obvious security reasons, it is probably best if such services are available over HTTPS.

Note: Some values cannot be provided in the URL passed to site. e.g. email addresses as usernames. In those situations you should use the separate user and password option.

Errors & Validation

Error handling and validation is handled in much the same manner as you‘re used to seeing in Active Record. Both the response code in the HTTP response and the body of the response are used to indicate that an error occurred.

Resource errors

When a GET is requested for a resource that does not exist, the HTTP 404 (Resource Not Found) response code will be returned from the server which will raise an ActiveResource::ResourceNotFound exception.

  # GET http://api.people.com:3000/people/999.xml
  ryan = Person.find(999) # 404, raises ActiveResource::ResourceNotFound

404 is just one of the HTTP error response codes that Active Resource will handle with its own exception. The following HTTP response codes will also result in these exceptions:

These custom exceptions allow you to deal with resource errors more naturally and with more precision rather than returning a general HTTP error. For example:

  begin
    ryan = Person.find(my_id)
  rescue ActiveResource::ResourceNotFound
    redirect_to :action => 'not_found'
  rescue ActiveResource::ResourceConflict, ActiveResource::ResourceInvalid
    redirect_to :action => 'new'
  end

Validation errors

Active Resource supports validations on resources and will return errors if any these validations fail (e.g., "First name can not be blank" and so on). These types of errors are denoted in the response by a response code of 422 and an XML representation of the validation errors. The save operation will then fail (with a false return value) and the validation errors can be accessed on the resource in question.

  ryan = Person.find(1)
  ryan.first # => ''
  ryan.save  # => false

  # When
  # PUT http://api.people.com:3000/people/1.xml
  # is requested with invalid values, the response is:
  #
  # Response (422):
  # <errors type="array"><error>First cannot be empty</error></errors>
  #

  ryan.errors.invalid?(:first)  # => true
  ryan.errors.full_messages     # => ['First cannot be empty']

Learn more about Active Resource‘s validation features in the ActiveResource::Validations documentation.

Timeouts

Active Resource relies on HTTP to access RESTful APIs and as such is inherently susceptible to slow or unresponsive servers. In such cases, your Active Resource method calls could \timeout. You can control the amount of time before Active Resource times out with the timeout variable.

  class Person < ActiveResource::Base
    self.site = "http://api.people.com:3000/"
    self.timeout = 5
  end

This sets the timeout to 5 seconds. You can adjust the timeout to a value suitable for the RESTful API you are accessing. It is recommended to set this to a reasonably low value to allow your Active Resource clients (especially if you are using Active Resource in a Rails application) to fail-fast (see en.wikipedia.org/wiki/Fail-fast) rather than cause cascading failures that could incapacitate your server.

When a \timeout occurs, an ActiveResource::TimeoutError is raised. You should rescue from ActiveResource::TimeoutError in your Active Resource method calls.

Internally, Active Resource relies on Ruby‘s Net::HTTP library to make HTTP requests. Setting timeout sets the read_timeout of the internal Net::HTTP instance to the same value. The default read_timeout is 60 seconds on most Ruby implementations.

Methods
Public Class methods
collection_path(prefix_options = {}, query_options = nil)

Gets the collection path for the REST resources. If the query_options parameter is omitted, Rails will split from the prefix_options.

Options

  • prefix_options - A hash to add a prefix to the request for nested URL‘s (e.g., :account_id => 19 would yield a URL like /accounts/19/purchases.xml).
  • query_options - A hash to add items to the query string for the request.

Examples

  Post.collection_path
  # => /posts.xml

  Comment.collection_path(:post_id => 5)
  # => /posts/5/comments.xml

  Comment.collection_path(:post_id => 5, :active => 1)
  # => /posts/5/comments.xml?active=1

  Comment.collection_path({:post_id => 5}, {:active => 1})
  # => /posts/5/comments.xml?active=1
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 432
432:       def collection_path(prefix_options = {}, query_options = nil)
433:         prefix_options, query_options = split_options(prefix_options) if query_options.nil?
434:         "#{prefix(prefix_options)}#{collection_name}.#{format.extension}#{query_string(query_options)}"
435:       end
connection(refresh = false)

An instance of ActiveResource::Connection that is the base \connection to the remote service. The refresh parameter toggles whether or not the \connection is refreshed at every request or not (defaults to false).

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 319
319:       def connection(refresh = false)
320:         if defined?(@connection) || superclass == Object
321:           @connection = Connection.new(site, format) if refresh || @connection.nil?
322:           @connection.user = user if user
323:           @connection.password = password if password
324:           @connection.timeout = timeout if timeout
325:           @connection
326:         else
327:           superclass.connection
328:         end
329:       end
create(attributes = {})

Creates a new resource instance and makes a request to the remote service that it be saved, making it equivalent to the following simultaneous calls:

  ryan = Person.new(:first => 'ryan')
  ryan.save

Returns the newly created resource. If a failure has occurred an exception will be raised (see save). If the resource is invalid and has not been saved then valid? will return false, while new? will still return true.

Examples

  Person.create(:name => 'Jeremy', :email => 'myname@nospam.com', :enabled => true)
  my_person = Person.find(:first)
  my_person.email # => myname@nospam.com

  dhh = Person.create(:name => 'David', :email => 'dhh@nospam.com', :enabled => true)
  dhh.valid? # => true
  dhh.new?   # => false

  # We'll assume that there's a validation that requires the name attribute
  that_guy = Person.create(:name => '', :email => 'thatguy@nospam.com', :enabled => true)
  that_guy.valid? # => false
  that_guy.new?   # => true
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 463
463:       def create(attributes = {})
464:         returning(self.new(attributes)) { |res| res.save }
465:       end
delete(id, options = {})

Deletes the resources with the ID in the id parameter.

Options

All options specify \prefix and query parameters.

Examples

  Event.delete(2) # sends DELETE /events/2

  Event.create(:name => 'Free Concert', :location => 'Community Center')
  my_event = Event.find(:first) # let's assume this is event with ID 7
  Event.delete(my_event.id) # sends DELETE /events/7

  # Let's assume a request to events/5/cancel.xml
  Event.delete(params[:id]) # sends DELETE /events/5
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 540
540:       def delete(id, options = {})
541:         connection.delete(element_path(id, options))
542:       end
element_path(id, prefix_options = {}, query_options = nil)

Gets the element path for the given ID in id. If the query_options parameter is omitted, Rails will split from the \prefix options.

Options

prefix_options - A \hash to add a \prefix to the request for nested URLs (e.g., :account_id => 19

                   would yield a URL like <tt>/accounts/19/purchases.xml</tt>).

query_options - A \hash to add items to the query string for the request.

Examples

  Post.element_path(1)
  # => /posts/1.xml

  Comment.element_path(1, :post_id => 5)
  # => /posts/5/comments/1.xml

  Comment.element_path(1, :post_id => 5, :active => 1)
  # => /posts/5/comments/1.xml?active=1

  Comment.element_path(1, {:post_id => 5}, {:active => 1})
  # => /posts/5/comments/1.xml?active=1
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 406
406:       def element_path(id, prefix_options = {}, query_options = nil)
407:         prefix_options, query_options = split_options(prefix_options) if query_options.nil?
408:         "#{prefix(prefix_options)}#{collection_name}/#{id}.#{format.extension}#{query_string(query_options)}"
409:       end
exists?(id, options = {})

Asserts the existence of a resource, returning true if the resource is found.

Examples

  Note.create(:title => 'Hello, world.', :body => 'Nothing more for now...')
  Note.exists?(1) # => true

  Note.exists(1349) # => false
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 551
551:       def exists?(id, options = {})
552:         if id
553:           prefix_options, query_options = split_options(options[:params])
554:           path = element_path(id, prefix_options, query_options)
555:           response = connection.head(path, headers)
556:           response.code.to_i == 200
557:         end
558:         # id && !find_single(id, options).nil?
559:       rescue ActiveResource::ResourceNotFound
560:         false
561:       end
find(*arguments)

Core method for finding resources. Used similarly to Active Record‘s find method.

Arguments

The first argument is considered to be the scope of the query. That is, how many resources are returned from the request. It can be one of the following.

  • :one - Returns a single resource.
  • :first - Returns the first resource found.
  • :last - Returns the last resource found.
  • :all - Returns every resource that matches the request.

Options

  • :from - Sets the path or custom method that resources will be fetched from.
  • :params - Sets query and \prefix (nested URL) parameters.

Examples

  Person.find(1)
  # => GET /people/1.xml

  Person.find(:all)
  # => GET /people.xml

  Person.find(:all, :params => { :title => "CEO" })
  # => GET /people.xml?title=CEO

  Person.find(:first, :from => :managers)
  # => GET /people/managers.xml

  Person.find(:last, :from => :managers)
  # => GET /people/managers.xml

  Person.find(:all, :from => "/companies/1/people.xml")
  # => GET /companies/1/people.xml

  Person.find(:one, :from => :leader)
  # => GET /people/leader.xml

  Person.find(:all, :from => :developers, :params => { :language => 'ruby' })
  # => GET /people/developers.xml?language=ruby

  Person.find(:one, :from => "/companies/1/manager.xml")
  # => GET /companies/1/manager.xml

  StreetAddress.find(1, :params => { :person_id => 1 })
  # => GET /people/1/street_addresses/1.xml
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 513
513:       def find(*arguments)
514:         scope   = arguments.slice!(0)
515:         options = arguments.slice!(0) || {}
516: 
517:         case scope
518:           when :all   then find_every(options)
519:           when :first then find_every(options).first
520:           when :last  then find_every(options).last
521:           when :one   then find_one(options)
522:           else             find_single(scope, options)
523:         end
524:       end
format()

Returns the current format, default is ActiveResource::Formats::XmlFormat.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 297
297:       def format
298:         read_inheritable_attribute(:format) || ActiveResource::Formats[:xml]
299:       end
format=(mime_type_reference_or_format)

Sets the format that attributes are sent and received in from a mime type reference:

  Person.format = :json
  Person.find(1) # => GET /people/1.json

  Person.format = ActiveResource::Formats::XmlFormat
  Person.find(1) # => GET /people/1.xml

Default format is :xml.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 288
288:       def format=(mime_type_reference_or_format)
289:         format = mime_type_reference_or_format.is_a?(Symbol) ?
290:           ActiveResource::Formats[mime_type_reference_or_format] : mime_type_reference_or_format
291: 
292:         write_inheritable_attribute(:format, format)
293:         connection.format = format if site
294:       end
headers()
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 331
331:       def headers
332:         @headers ||= {}
333:       end
new(attributes = {})

Constructor method for \new resources; the optional attributes parameter takes a \hash of attributes for the \new resource.

Examples

  my_course = Course.new
  my_course.name = "Western Civilization"
  my_course.lecturer = "Don Trotter"
  my_course.save

  my_other_course = Course.new(:name => "Philosophy: Reason and Being", :lecturer => "Ralph Cling")
  my_other_course.save
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 651
651:     def initialize(attributes = {})
652:       @attributes     = {}
653:       @prefix_options = {}
654:       load(attributes)
655:     end
password()

Gets the \password for REST HTTP authentication.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 264
264:       def password
265:         # Not using superclass_delegating_reader. See +site+ for explanation
266:         if defined?(@password)
267:           @password
268:         elsif superclass != Object && superclass.password
269:           superclass.password.dup.freeze
270:         end
271:       end
password=(password)

Sets the \password for REST HTTP authentication.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 274
274:       def password=(password)
275:         @connection = nil
276:         @password = password
277:       end
prefix(options={})

Gets the \prefix for a resource‘s nested URL (e.g., prefix/collectionname/1.xml) This method is regenerated at runtime based on what the \prefix is set to.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 344
344:       def prefix(options={})
345:         default = site.path
346:         default << '/' unless default[-1..-1] == '/'
347:         # generate the actual method based on the current site path
348:         self.prefix = default
349:         prefix(options)
350:       end
prefix=(value = '/')

Sets the \prefix for a resource‘s nested URL (e.g., prefix/collectionname/1.xml). Default value is site.path.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 361
361:       def prefix=(value = '/')
362:         # Replace :placeholders with '#{embedded options[:lookups]}'
363:         prefix_call = value.gsub(/:\w+/) { |key| "\#{options[#{key}]}" }
364: 
365:         # Clear prefix parameters in case they have been cached
366:         @prefix_parameters = nil
367: 
368:         # Redefine the new methods.
369:         code = "def prefix_source() \"\#{value}\" end\ndef prefix(options={}) \"\#{prefix_call}\" end\n"
370:         silence_warnings { instance_eval code, __FILE__, __LINE__ }
371:       rescue
372:         logger.error "Couldn't set prefix: #{$!}\n  #{code}"
373:         raise
374:       end
prefix_source()

An attribute reader for the source string for the resource path \prefix. This method is regenerated at runtime based on what the \prefix is set to.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 354
354:       def prefix_source
355:         prefix # generate #prefix and #prefix_source methods first
356:         prefix_source
357:       end
site()

Gets the URI of the REST resources to map for this class. The site variable is required for Active Resource‘s mapping to work.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 211
211:       def site
212:         # Not using superclass_delegating_reader because don't want subclasses to modify superclass instance
213:         #
214:         # With superclass_delegating_reader
215:         #
216:         #   Parent.site = 'http://anonymous@test.com'
217:         #   Subclass.site # => 'http://anonymous@test.com'
218:         #   Subclass.site.user = 'david'
219:         #   Parent.site # => 'http://david@test.com'
220:         #
221:         # Without superclass_delegating_reader (expected behaviour)
222:         #
223:         #   Parent.site = 'http://anonymous@test.com'
224:         #   Subclass.site # => 'http://anonymous@test.com'
225:         #   Subclass.site.user = 'david' # => TypeError: can't modify frozen object
226:         #
227:         if defined?(@site)
228:           @site
229:         elsif superclass != Object && superclass.site
230:           superclass.site.dup.freeze
231:         end
232:       end
site=(site)

Sets the URI of the REST resources to map for this class to the value in the site argument. The site variable is required for Active Resource‘s mapping to work.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 236
236:       def site=(site)
237:         @connection = nil
238:         if site.nil?
239:           @site = nil
240:         else
241:           @site = create_site_uri_from(site)
242:           @user = URI.decode(@site.user) if @site.user
243:           @password = URI.decode(@site.password) if @site.password
244:         end
245:       end
timeout()

Gets the number of seconds after which requests to the REST API should time out.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 308
308:       def timeout
309:         if defined?(@timeout)
310:           @timeout
311:         elsif superclass != Object && superclass.timeout
312:           superclass.timeout
313:         end
314:       end
timeout=(timeout)

Sets the number of seconds after which requests to the REST API should time out.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 302
302:       def timeout=(timeout)
303:         @connection = nil
304:         @timeout = timeout
305:       end
user()

Gets the \user for REST HTTP authentication.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 248
248:       def user
249:         # Not using superclass_delegating_reader. See +site+ for explanation
250:         if defined?(@user)
251:           @user
252:         elsif superclass != Object && superclass.user
253:           superclass.user.dup.freeze
254:         end
255:       end
user=(user)

Sets the \user for REST HTTP authentication.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 258
258:       def user=(user)
259:         @connection = nil
260:         @user = user
261:       end
Public Instance methods
==(other)

Test for equality. Resource are equal if and only if other is the same object or is an instance of the same class, is not new?, and has the same id.

Examples

  ryan = Person.create(:name => 'Ryan')
  jamie = Person.create(:name => 'Jamie')

  ryan == jamie
  # => false (Different name attribute and id)

  ryan_again = Person.new(:name => 'Ryan')
  ryan == ryan_again
  # => false (ryan_again is new?)

  ryans_clone = Person.create(:name => 'Ryan')
  ryan == ryans_clone
  # => false (Different id attributes)

  ryans_twin = Person.find(ryan.id)
  ryan == ryans_twin
  # => true
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 746
746:     def ==(other)
747:       other.equal?(self) || (other.instance_of?(self.class) && !other.new? && other.id == id)
748:     end
clone()

Returns a \clone of the resource that hasn‘t been assigned an id yet and is treated as a \new resource.

  ryan = Person.find(1)
  not_ryan = ryan.clone
  not_ryan.new?  # => true

Any active resource member attributes will NOT be cloned, though all other attributes are. This is to prevent the conflict between any prefix_options that refer to the original parent resource and the newly cloned parent resource that does not exist.

  ryan = Person.find(1)
  ryan.address = StreetAddress.find(1, :person_id => ryan.id)
  ryan.hash = {:not => "an ARes instance"}

  not_ryan = ryan.clone
  not_ryan.new?            # => true
  not_ryan.address         # => NoMethodError
  not_ryan.hash            # => {:not => "an ARes instance"}
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 677
677:     def clone
678:       # Clone all attributes except the pk and any nested ARes
679:       cloned = attributes.reject {|k,v| k == self.class.primary_key || v.is_a?(ActiveResource::Base)}.inject({}) do |attrs, (k, v)|
680:         attrs[k] = v.clone
681:         attrs
682:       end
683:       # Form the new resource - bypass initialize of resource with 'new' as that will call 'load' which
684:       # attempts to convert hashes into member objects and arrays into collections of objects.  We want
685:       # the raw objects to be cloned so we bypass load by directly setting the attributes hash.
686:       resource = self.class.new({})
687:       resource.prefix_options = self.prefix_options
688:       resource.send :instance_variable_set, '@attributes', cloned
689:       resource
690:     end
destroy()

Deletes the resource from the remote service.

Examples

  my_id = 3
  my_person = Person.find(my_id)
  my_person.destroy
  Person.find(my_id) # 404 (Resource Not Found)

  new_person = Person.create(:name => 'James')
  new_id = new_person.id # => 7
  new_person.destroy
  Person.find(new_id) # 404 (Resource Not Found)
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 809
809:     def destroy
810:       connection.delete(element_path, self.class.headers)
811:     end
dup()

Duplicate the current resource without saving it.

Examples

  my_invoice = Invoice.create(:customer => 'That Company')
  next_invoice = my_invoice.dup
  next_invoice.new? # => true

  next_invoice.save
  next_invoice == my_invoice # => false (different id attributes)

  my_invoice.customer   # => That Company
  next_invoice.customer # => That Company
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 773
773:     def dup
774:       returning self.class.new do |resource|
775:         resource.attributes     = @attributes
776:         resource.prefix_options = @prefix_options
777:       end
778:     end
encode(options={})

Returns the serialized string representation of the resource in the configured serialization format specified in ActiveResource::Base.format. The options applicable depend on the configured encoding format.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 894
894:     def encode(options={})
895:       case self.class.format
896:         when ActiveResource::Formats[:xml]
897:           self.class.format.encode(attributes, {:root => self.class.element_name}.merge(options))
898:         else
899:           self.class.format.encode(attributes, options)
900:       end
901:     end
eql?(other)

Tests for equality (delegates to ==).

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 751
751:     def eql?(other)
752:       self == other
753:     end
exists?()

Evaluates to true if this resource is not new? and is found on the remote service. Using this method, you can check for resources that may have been deleted between the object‘s instantiation and actions on it.

Examples

  Person.create(:name => 'Theodore Roosevelt')
  that_guy = Person.find(:first)
  that_guy.exists? # => true

  that_lady = Person.new(:name => 'Paul Bean')
  that_lady.exists? # => false

  guys_id = that_guy.id
  Person.delete(guys_id)
  that_guy.exists? # => false
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 829
829:     def exists?
830:       !new? && self.class.exists?(to_param, :params => prefix_options)
831:     end
hash()

Delegates to id in order to allow two resources of the same type and \id to work with something like:

  [Person.find(1), Person.find(2)] & [Person.find(1), Person.find(4)] # => [Person.find(1)]
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 757
757:     def hash
758:       id.hash
759:     end
id()

Gets the \id attribute of the resource.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 710
710:     def id
711:       attributes[self.class.primary_key]
712:     end
id=(id)

Sets the \id attribute of the resource.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 715
715:     def id=(id)
716:       attributes[self.class.primary_key] = id
717:     end
load(attributes)

A method to manually load attributes from a \hash. Recursively loads collections of resources. This method is called in initialize and create when a \hash of attributes is provided.

Examples

  my_attrs = {:name => 'J&J Textiles', :industry => 'Cloth and textiles'}
  my_attrs = {:name => 'Marty', :colors => ["red", "green", "blue"]}

  the_supplier = Supplier.find(:first)
  the_supplier.name # => 'J&M Textiles'
  the_supplier.load(my_attrs)
  the_supplier.name('J&J Textiles')

  # These two calls are the same as Supplier.new(my_attrs)
  my_supplier = Supplier.new
  my_supplier.load(my_attrs)

  # These three calls are the same as Supplier.create(my_attrs)
  your_supplier = Supplier.new
  your_supplier.load(my_attrs)
  your_supplier.save
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 939
939:     def load(attributes)
940:       raise ArgumentError, "expected an attributes Hash, got #{attributes.inspect}" unless attributes.is_a?(Hash)
941:       @prefix_options, attributes = split_options(attributes)
942:       attributes.each do |key, value|
943:         @attributes[key.to_s] =
944:           case value
945:             when Array
946:               resource = find_or_create_resource_for_collection(key)
947:               value.map { |attrs| attrs.is_a?(String) ? attrs.dup : resource.new(attrs) }
948:             when Hash
949:               resource = find_or_create_resource_for(key)
950:               resource.new(value)
951:             else
952:               value.dup rescue value
953:           end
954:       end
955:       self
956:     end
new?()

A method to determine if the resource a \new object (i.e., it has not been POSTed to the remote service yet).

Examples

  not_new = Computer.create(:brand => 'Apple', :make => 'MacBook', :vendor => 'MacMall')
  not_new.new? # => false

  is_new = Computer.new(:brand => 'IBM', :make => 'Thinkpad', :vendor => 'IBM')
  is_new.new? # => true

  is_new.save
  is_new.new? # => false
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 705
705:     def new?
706:       id.nil?
707:     end
reload()

A method to \reload the attributes of this object from the remote web service.

Examples

  my_branch = Branch.find(:first)
  my_branch.name # => "Wislon Raod"

  # Another client fixes the typo...

  my_branch.name # => "Wislon Raod"
  my_branch.reload
  my_branch.name # => "Wilson Road"
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 914
914:     def reload
915:       self.load(self.class.find(to_param, :params => @prefix_options).attributes)
916:     end
respond_to?(method, include_priv = false)

A method to determine if an object responds to a message (e.g., a method call). In Active Resource, a Person object with a name attribute can answer true to my_person.respond_to?(:name), my_person.respond_to?(:name=), and my_person.respond_to?(:name?).

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 964
964:     def respond_to?(method, include_priv = false)
965:       method_name = method.to_s
966:       if attributes.nil?
967:         return super
968:       elsif attributes.has_key?(method_name)
969:         return true
970:       elsif ['?','='].include?(method_name.last) && attributes.has_key?(method_name.first(-1))
971:         return true
972:       end
973:       # super must be called at the end of the method, because the inherited respond_to?
974:       # would return true for generated readers, even if the attribute wasn't present
975:       super
976:     end
save()

A method to \save (POST) or \update (PUT) a resource. It delegates to create if a \new object, update if it is existing. If the response to the \save includes a body, it will be assumed that this body is XML for the final object as it looked after the \save (which would include attributes like created_at that weren‘t part of the original submit).

Examples

  my_company = Company.new(:name => 'RoleModel Software', :owner => 'Ken Auer', :size => 2)
  my_company.new? # => true
  my_company.save # sends POST /companies/ (create)

  my_company.new? # => false
  my_company.size = 10
  my_company.save # sends PUT /companies/1 (update)
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 793
793:     def save
794:       new? ? create : update
795:     end
to_json(options={})

Returns a JSON string representing the model. Some configuration is available through options.

Options

The options are passed to the to_json method on each attribute, so the same options as the to_json methods in Active Support.

  • :only - Only include the specified attribute or list of attributes in the serialized output. Attribute names must be specified as strings.
  • :except - Do not include the specified attribute or list of attributes in the serialized output. Attribute names must be specified as strings.

Examples

  person = Person.new(:first_name => "Jim", :last_name => "Smith")
  person.to_json
  # => {"first_name": "Jim", "last_name": "Smith"}

  person.to_json(:only => ["first_name"])
  # => {"first_name": "Jim"}

  person.to_json(:except => ["first_name"])
  # => {"last_name": "Smith"}
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 887
887:     def to_json(options={})
888:       attributes.to_json(options)
889:     end
to_param()

Allows Active Resource objects to be used as parameters in Action Pack URL generation.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 720
720:     def to_param
721:       id && id.to_s
722:     end
to_xml(options={})

A method to convert the the resource to an XML string.

Options

The options parameter is handed off to the to_xml method on each attribute, so it has the same options as the to_xml methods in Active Support.

  • :indent - Set the indent level for the XML output (default is +2+).
  • :dasherize - Boolean option to determine whether or not element names should replace underscores with dashes (default is false).
  • :skip_instruct - Toggle skipping the +instruct!+ call on the XML builder that generates the XML declaration (default is false).

Examples

  my_group = SubsidiaryGroup.find(:first)
  my_group.to_xml
  # => <?xml version="1.0" encoding="UTF-8"?>
  #    <subsidiary_group> [...] </subsidiary_group>

  my_group.to_xml(:dasherize => true)
  # => <?xml version="1.0" encoding="UTF-8"?>
  #    <subsidiary-group> [...] </subsidiary-group>

  my_group.to_xml(:skip_instruct => true)
  # => <subsidiary_group> [...] </subsidiary_group>
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 858
858:     def to_xml(options={})
859:       attributes.to_xml({:root => self.class.element_name}.merge(options))
860:     end
Protected Instance methods
collection_path(options = nil)
      # File vendor/rails/activeresource/lib/active_resource/base.rb, line 1014
1014:       def collection_path(options = nil)
1015:         self.class.collection_path(options || prefix_options)
1016:       end
connection(refresh = false)
     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 980
980:       def connection(refresh = false)
981:         self.class.connection(refresh)
982:       end
create()

Create (i.e., \save to the remote service) the \new resource.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 992
992:       def create
993:         returning connection.post(collection_path, encode, self.class.headers) do |response|
994:           self.id = id_from_response(response)
995:           load_attributes_from_response(response)
996:         end
997:       end
element_path(options = nil)
      # File vendor/rails/activeresource/lib/active_resource/base.rb, line 1010
1010:       def element_path(options = nil)
1011:         self.class.element_path(to_param, options || prefix_options)
1012:       end
id_from_response(response)

Takes a response from a typical create post and pulls the ID out

      # File vendor/rails/activeresource/lib/active_resource/base.rb, line 1006
1006:       def id_from_response(response)
1007:         response['Location'][/\/([^\/]*?)(\.\w+)?$/, 1]
1008:       end
load_attributes_from_response(response)
      # File vendor/rails/activeresource/lib/active_resource/base.rb, line 999
 999:       def load_attributes_from_response(response)
1000:         if response['Content-Length'] != "0" && response.body.strip.size > 0
1001:           load(self.class.format.decode(response.body))
1002:         end
1003:       end
update()

Update the resource on the remote service.

     # File vendor/rails/activeresource/lib/active_resource/base.rb, line 985
985:       def update
986:         returning connection.put(element_path(prefix_options), encode, self.class.headers) do |response|
987:           load_attributes_from_response(response)
988:         end
989:       end